///////////////////////////////    _LeMur_
#define _CRT_SECURE_NO_WARNINGS
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <cstring>
#include <complex>
#include <cassert>
#include <cfloat>
#include <memory>
#include <chrono>
#include <random>
#include <limits>
#include <bitset>
#include <cstdio>
#include <vector>
#include <string>
#include <stack>
#include <tuple>
#include <queue>
#include <ctime>
#include <cmath>
#include <list>
#include <map>
#include <set>

using namespace std;

const int N = 300005;
const int inf = 1000 * 1000 * 1000;
const int mod = 998244353;
// mt19937 myrand(chrono::steady_clock::now().time_since_epoch().count());
mt19937 myrand(373);

int n, m;
vector < pair<int, int> > g[N];

vector < vector<int> > G;
vector < vector<int> > indices;
vector < vector<int> > arr;
vector <int> gcycles[N]; 

bool used[N];
bool mark[N];
int parent[N], id[N];

void dfs(int v, int p) {
  used[v] = true;

  for (int i = 0; i < (int)g[v].size(); i++) {
    int to = g[v][i].first;
    int ind = g[v][i].second;

    if (to == p || mark[ind]) continue;
    
    if (used[to]) {
      int gag = v;
      vector <int> cycle;
      vector <int> ids;

      while (gag != to) {
        mark[ id[gag] ] = true;
        cycle.push_back(gag);
        ids.push_back(id[gag]);
        gag = parent[gag];
      }

      cycle.push_back(gag);
      ids.push_back(ind);
      mark[ind] = true;

      gcycles[to].push_back((int)G.size());
      G.push_back(cycle);
      indices.push_back(ids);

      continue;
    }

    id[to] = ind;
    parent[to] = v;
    dfs(to, v);
  }
}

int sum[N];

void rec(int v, int p) {
  for (int id: gcycles[v]) {
    sum[v] += (int)G[id].size();
    for (int to: G[id]) {
      if (to == v) continue;
      rec(to, v);
      sum[v] += sum[to];
    }
  }

  for (int id: gcycles[v]) {
    int len = (int)G[id].size();

    int counter_two = 0;
    int two = 0, one = 0;

    for (int i = 0; i < len; i++) {
      int to = G[id][i];

      if (i == len - 1) {
        if (len % 2) {
          if (counter_two % 2) {
            arr[id].push_back(1);
          } else {
            arr[id].push_back(2);
          }
        } else {
          if (counter_two % 2) {
            arr[id].push_back(2);
          } else {
            arr[id].push_back(1);
          }
        }
      } else {
        if (sum[to] % 2 == 0) {
          arr[id].push_back(1);
        } else {
          ++counter_two;
          arr[id].push_back(2);
        }
      }

      if (arr[id].back() == 2) {
        ++two;
      } else {
        ++one;
      }
    }

    int minus_two, minus_one;
    if (two % 2 == 0) {
      minus_two = two / 2;
      minus_one = one / 2;
    } else {
      minus_two = (two - 1) / 2;
      minus_one = (one - 2) / 2 + 2;
    }

    int total_sum = 0;
    for (int i = 0; i < len; i++) {
      if (arr[id][i] == 1) {
        if (minus_one > 0) {
          --minus_one;
          arr[id][i] = -1;
        }
      } else {
        if (minus_two > 0) {
          --minus_two;
          arr[id][i] = -2;
        }
      }

      total_sum += arr[id][i];
    }

    assert(total_sum == 0);
  }
}

int answ[N];

void solve(int v, int p, int mn, int mx) {
  vector < pair<int, int> > two, one;

  for (int id: gcycles[v]) {
    int len = (int)G[id].size();

    int id1 = indices[id][len - 1];
    int id2 = indices[id][len - 2];

    // answ[id1] + arr[id][len - 1] = answ[id2]
    if (arr[id][len - 1] < 0) {
      if (arr[id][len - 1] == -1) {
        one.emplace_back(id2, id1);
      } else {
        two.emplace_back(id2, id1);
      }
    } else {
      if (arr[id][len - 1] == 1) {
        one.emplace_back(id1, id2);
      } else {
        two.emplace_back(id1, id2);
      }
    }
  }

  int cur = mx;

  if ((int)two.size() % 2) {
    assert(mx - mn == 2);

    answ[ two.back().first ] = mn + 1;
    answ[ two.back().second ] = mx + 1;

    two.pop_back();
    cur = mx + 1;
  }

  for (int i = 0; i < (int)two.size(); i += 2) {
    answ[ two[i].first ] = cur + 1;
    answ[ two[i + 1].first ] = cur + 2;
    answ[ two[i].second ] = cur + 3;
    answ[ two[i + 1].second ] = cur + 4;
    cur += 4;
  }

  for (int i = 0; i < (int)one.size(); i++) {
    answ[ one[i].first ] = cur + 1;
    answ[ one[i].second ] = cur + 2;
    cur += 2;
  }

  for (int id: gcycles[v]) {
    int len = (int)G[id].size();

    for (int i = len - 3; i >= 0; i--) {
      answ[ indices[id][i] ] = answ[ indices[id][i + 1] ] + arr[id][i + 1];
    }
  }

  for (int id: gcycles[v]) {
    int len = (int)G[id].size();

    for (int i = 0; i < len; i++) {
      int to = G[id][i];

      if (to == v) continue;

      int color1 = answ[ indices[id][i] ];
      int color2 = answ[ indices[id][(i - 1 + len) % len] ];

      solve(to, v, min(color1, color2), max(color1, color2));
    }
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);

  cin >> n >> m;

  for (int i = 1; i <= m; i++) {
    int a, b;
    cin >> a >> b;
    g[a].emplace_back(b, i);
    g[b].emplace_back(a, i);
  }

  if (m % 2) {
    cout << "NO" << endl;
    return 0;
  }

  cout << "YES" << endl;

  dfs(1, -1);
  arr.resize((int)G.size());
  rec(1, -1);
  solve(1, -1, 0, 1);

  int mn, mx;
  for (int i = 1; i <= m; i++) {
    if (i == 1 || answ[i] < mn) {
      mn = answ[i];
    }
    if (i == 1 || answ[i] > mx) {
      mx = answ[i];
    }
  }

  cout << mx + 1 - mn << endl;
  for (int i = 1; i <= m; i++) {
    cout << answ[i] + 1 - mn << " ";
  }
  cout << endl;
  return 0;
}
