private const val SET = 2
private const val UNSET = 0
private const val TRUE = 1
private const val FALSE = 0

fun main() {
    val n = readln().toInt()
    val a = Array(4) { ArrayList<Int>() }
    val t = IntArray(n) { i ->
        val (op, res) = readln().split(" ", limit = 2)
        var t = when (op) {
            "set" -> SET
            "unset" -> UNSET
            else -> error("Unexpected op: $op")
        }
        t += when (res) {
            "true" -> TRUE
            "false" -> FALSE
            else -> error("Unexpected res: $res")
        }
        a[t].add(i)
        t
    }
    val m = readln().toInt()
    val g = Array(n) { ArrayList<Int>() }
    repeat(m) {
        val (a, b) = readln().split(" ", limit = 2).map { it.toInt() - 1 }
        require(a != b)
        g[a].add(b)
    }
    val setTrueCnt = a[SET + TRUE].size
    val unsetTrueCnt = a[UNSET + TRUE].size
    val trueCnt = setTrueCnt + unsetTrueCnt
    when (trueCnt) {
        0 -> {
            if (a[SET + FALSE].size > 0) {
                println(-1)
                return
            }
        }
        1 -> {
            if (setTrueCnt != 1) {
                println(-1)
                return
            }
            val setTrue = a[SET + TRUE].single()
            for (setFalse in a[SET + FALSE]) {
                g[setTrue].add(setFalse)
            }
        }
        2 -> {
            if (setTrueCnt != 1 || unsetTrueCnt != 1) {
                println(-1)
                return
            }
            val setTrue = a[SET + TRUE].single()
            val unsetTrue = a[UNSET + TRUE].single()
            for (setFalse in a[SET + FALSE]) {
                g[setTrue].add(setFalse)
                g[setFalse].add(unsetTrue)
            }
        }
        else -> error("Too many successful: $trueCnt")
    }
    val c = IntArray(n)
    for (i in 0..<n) for (j in g[i]) c[j]++
    val q = Array(4) { ArrayList<Int>() }
    for (i in 0..<n) if (c[i] == 0) {
        q[t[i]].add(i)
    }
    val ans = ArrayList<Int>()
    fun add(i: Int) {
        check(c[i] == 0)
        ans += i
        for (j in g[i]) if (--c[j] == 0) {
            q[t[j]].add(j)
        }
    }
    var bit = 0
    while (ans.size < n) when (bit) {
        0 -> {
            if (q[UNSET + FALSE].isNotEmpty()) {
                add(q[UNSET + FALSE].removeLast())
                continue
            }
            if (q[SET + TRUE].isEmpty()) {
                println(-1)
                return
            }
            add(q[SET + TRUE].removeLast())
            bit = 1
        }
        1 -> {
            if (q[SET + FALSE].isNotEmpty()) {
                add(q[SET + FALSE].removeLast())
                continue
            }
            if (q[UNSET + TRUE].isEmpty()) {
                println(-1)
                return
            }
            add(q[UNSET + TRUE].removeLast())
            bit = 0
        }
        else -> error("bit=$bit")
    }
    println(ans.joinToString(" ") { "${it + 1}"} )
}