#include <bits/stdc++.h>
#pragma GCC optimize ("O3", "unroll-all-loops")
#pragma GCC target ("sse4.2")

using namespace std;

#define F first
#define S second
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sz(a) (a).size()
#define rep(i, a, b) for (int i = (a); i < (b); ++i)
typedef long long       ll;
typedef long double     ld;
typedef pair<ll, ll>   pll; 
typedef pair<int, int> pii; 

typedef vector<int> vi; 
typedef vector<ll> vll; 

const long long kk = 1000;
const long long ml = kk * kk;
const long long mod = ml * kk + 7;
const long long inf = ml * ml * ml + 7; 

template<class T, class U> inline istream& operator>>(istream& str, pair<T, U> &p) { return str >> p.F >> p.S; }
template<class T, class U> inline ostream& operator<<(ostream& str, const pair<T, U> &p) { str << p.F << ' ' << p.S << ' '; return str; }
template<class T> inline istream& operator>>(istream& str, vector<T> &a) { for (auto &i : a) str >> i; return str; }
template<class T> inline ostream& operator<<(ostream& str, const vector<T> &a) { for (auto &i : a) str << i << ' '; return str; }

void flush() { cout << flush; }
void flushln() { cout << endl; }
template<class T> void read(T &x) { cin >> x; }
template<class T, class ...U> void read(T &x, U&... u) { read(x); read(u...); }
template<class T> void print(const T &x) { cout << x; }
template<class T, class ...U> void print(const T &x, const U&... u) { print(x); print(u...); }
template<class ...T> void println(const T&... u) { print(u..., '\n'); }
template<class T> void eprint(const T &x) { cerr << x; }
template<class T, class ...U> void eprint(const T &x, const U&... u) { eprint(x); eprint(u...); }
template<class ...T> void eprintln(const T&... u) { eprint(u..., '\n'); }

#ifdef DEBUG
    mt19937 rng(1033);
#else
    mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());    
    #define cerr if(false)cerr
    #define eprintln if(false)eprintln
    #define eprint if(false)eprint
#endif
int rnd(int mod) { return uniform_int_distribution<int>(0, mod - 1)(rng); }




int n;

pair<string, char> rem(string s, int pos) {
    int n = s.size();
    string res;
    char res2;
    for (int i = 0; i < n; i++)
        if (i == pos)
            res2 = s[i];
        else
            res += s[i];
    return {res, res2};
}

string put(string s, char c, int pos) {
    string t;
    for (int i = 0; i < pos; i++)
        t += s[i];
    t += c;
    for (int i = pos; i < s.size(); i++)
        t += s[i];
    return t;
}


bool incorrect_num(string s) {
    if (0 == s.size() || s.size() > 10)
        return true;
    if (s[0] == '0' && s.size() > 1)
        return true;
    return false;
}

ll res(string s) {
    s += "=";
    int tp = 1;
    ll val = 0;
    ll res = 0;
    for (auto i : s) {
        if ('0' <= i && i <= '9')
            val *= 10, val += (i - '0');
        else {
            res += tp ? val : -val;
            tp = (i == '+');
            val = 0;
        }
    }
    return res;
}

bool eval(string s) {
    vector<string> nums(1, "");
    for (auto i : s) {
        if ('0' <= i && i <= '9')
            nums.back() += i;
        else
            nums.push_back("");
    }

    for (auto i : nums)
        if (incorrect_num(i)) {
            cerr << "for " << s << " incorrect " << i << endl;
            return false;
        }

    vector<string> parts(1, "");
    for (auto i : s) {
        if (i == '=')
            parts.push_back("");
        else
            parts.back() += i;
    }

    cerr << "result for " << parts[0] << " : " << res(parts[0]) << endl;
    cerr << "result for " << parts[1] << " : " << res(parts[1]) << endl;
    return res(parts[0]) == res(parts[1]);
}

void solve() {
    string s;
    cin >> s;
    if (eval(s)) {
        cout << "Correct\n";
        return;
    }
    n = s.size();
    for (int i = 0; i < n; i++) {
        string t;
        char c;
        tie(t, c) = rem(s, i);
        if (!('0' <= c && c <= '9'))
            continue;
        for (int j = 0; j < n; j++) {
            string p = put(t, c, j);
            if (eval(p)) {
                cout << p << '\n';
                return;
            }
        }
    }

    cout << "Impossible\n";

}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cout << fixed << setprecision(20);
    int t = 1; 
    // cin >> t;
    while (t--)
        solve();

    #ifdef DEBUG
        cerr << "Runtime is: " << clock() * 1.0 / CLOCKS_PER_SEC << endl;
    #endif
}
