#include <bits/stdc++.h>
using namespace std;

void solve_() {
    int n;
    cin >> n;
    array<string, 2> a;
    cin >> a[0] >> a[1];
    vector<int> bord;
    vector<int> pref(n + 1);
    pref[0] = 0;
    bord.push_back(0);
    for (int i = 0; i < n; ++i) {
        int cnt = (a[0][i] == '.') + (a[1][i] == '.');
        pref[i + 1] = (pref[i] ^ (cnt & 1));
        if (cnt == 2) continue;
        if (cnt == 1) {
            bord.push_back(i + 1 - pref[i + 1] % 2);
        } else {
            bord.push_back(i);
            bord.push_back(i + 1);
        }
    }
    bord.push_back(n);
    bool is_0 = false;
    bool is_multiple = false;
    for (int t = 1; t < (int)bord.size(); ++t) {
        int l = bord[t - 1];
        int r = bord[t];
        if (pref[r] ^ pref[l]) {
            is_0 = true;
        }
        if (r - l >= 2) {
            if (a[0][l] == '.' && a[1][l] == '.') {
                is_multiple = true;
            } else {
                int pos1 = (a[1][l] == '#');
                int pos2 = (a[1][r - 1] == '#');
                if ((pos1 ^ pos2) != (r ^ l) % 2) {
                    is_0 = true;
                }
            }
        }
    }
    if (is_0) {
        cout << "None\n";
    } else if (is_multiple) {
        cout << "Multiple\n";
    } else {
        cout << "Unique\n";
    }
}

#define MULTITEST

signed main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif
    int tst = 1;
#ifdef MULTITEST
    cin >> tst;
#endif // MULTITEST
    while (tst--) {
        solve_();
    }
    return 0;
}