#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>

using namespace std;

// #define int long long
typedef long long ll;
typedef long double ld;
const int MAXN = 2e5 + 5;
ll a[MAXN], d[MAXN], leng[MAXN];
ll pref_a[MAXN], pref_l[MAXN];
ll max_start[MAXN];

void solve() {
    int n, m, q;
    cin >> n >> m >> q;
    vector<pair<ll, ll>> hh(n);
    for (int i = 0; i < n; ++i) {
        cin >> hh[i].second;
    }
    for (int i = 0; i < n; ++i) {
        cin >> hh[i].first;
    }
    sort(hh.begin(), hh.end());
    for (int i = 0; i < n; ++i) {
        a[i] = hh[i].second;
        pref_a[i + 1] = pref_a[i] + a[i];
    }
    for (int i = 0; i < n; ++i) {
        d[i] = hh[i].first;
    }
    for (int i = 0; i < m; ++i) {
        cin >> leng[i];
        pref_l[i + 1] = pref_l[i] + leng[i];
    }
    max_start[n] = 1e18;
    for (int i = n - 1; i >= 0; --i) {
        max_start[i] = min(d[i], max_start[i + 1]) - a[i];
    }
    while (q--) {
        ll t;
        cin >> t;
        int l = 0, r = m + 1;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            ll lll = pref_l[mid];
            if (lll > t) {
                r = mid;
                continue;
            }
            int l_a = 0, r_a = n + 1;
            while (r_a - l_a > 1) {
                int mid_a = (l_a + r_a) / 2;
                if (lll + pref_a[mid_a] <= t) {
                    l_a = mid_a;
                }
                else {
                    r_a = mid_a;
                }
            }
            int cnt_a = l_a;
            if (max_start[cnt_a] >= lll + pref_a[cnt_a]) {
                l = mid;
            }
            else {
                r = mid;
            }
        }
        cout << l << " ";
    }
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t;
    for (int tt =0; tt < t; tt++) {
        solve();
    }

    return 0;
}
