#include <bits/stdc++.h>
using namespace std;
#ifndef DEBUG
#define cerr if (false) cerr
#endif

#define int long long

typedef long long ll;
typedef long double ld;

const int MAXN = 4e5 + 10;

void solve() {
    int n, m, q;
    cin >> n >> m >> q;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];

    vector<int> d(n);
    for (int i = 0; i < n; ++i) cin >> d[i];

    vector<int> l(m);
    for (int i = 0; i < m; ++i) cin >> l[i];
    for (int i = 1; i < m; ++i)
        l[i] += l[i - 1];

    vector<int> t(q);
    for (int i = 0; i < q; ++i) cin >> t[i];

    vector<int> ord(n);
    for (int i = 0; i < n; ++i) ord[i] = i;

    sort(ord.begin(), ord.end(), [&](int i, int j) {
        if (d[i] == d[j])
            return a[i] < a[j];
        return d[i] < d[j];
    });

    int T = 1e18;

    vector<int> st(n);
    for (int i = n - 1; i >= 0; --i) {
        T = min(T, d[ord[i]]);
        T -= a[ord[i]];
        st[i] = T;
    }
    int s = 0;
    vector<int> sa(n + 1);
    for (int i = 0; i < n; ++i) {
        sa[i + 1] = (s += a[ord[i]]);
    }


    for (int time_ : t) {
        int i = upper_bound(st.begin(), st.end(), time_) - st.begin() - 1;
        int free_time = time_ - (i >= 0 ? sa[i] + min(a[ord[i]], time_ - st[i]) : 0);
        cerr << time_ << '\n';
        cerr << (i >= 0 ? sa[i] : 0) << '\n';
        cerr << (i >= 0 ? min(a[ord[i]], time_ - st[i]) : 0) << '\n';
        cerr << free_time << '\n';
        cerr << '\n';
        

        int cnt = upper_bound(l.begin(), l.end(), free_time) - l.begin();
        cout << cnt << ' ';
    }
    cout << '\n';
}

signed main() {
    #ifdef DEBUG
        freopen("input.in", "r", stdin);
        freopen("output.out", "w", stdout);
    #endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) solve();
}