#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

const int MIN_T = 1;
const int MAX_T = (int) 1e3;

const int MIN_W = 3;
const int MAX_W = (int) 4e3;

const int MAX_SUM = (int) 8e3;

int main(int argc, char* argv[]) {
  registerValidation(argc, argv);

  int t = inf.readInt(MIN_T, MAX_T, "t");
  inf.readEoln();

  int sum = 0;

  for (int q = 1; q <= t; q++) {
    setTestCase(q);
    int W = inf.readInt(MIN_W, MAX_W, "W");
    inf.readSpace();
    int H = inf.readInt(MIN_W, MAX_W, "H");
    inf.readEoln();

    sum += W + H;
    ensuref(sum <= MAX_SUM, "sum of W+H is too large: %d > %d", sum, MAX_SUM);

    for (int i = 0; i < 2; i++) {
      int w = inf.readInt(1, W - 2, "w_" + to_string(i + 1));
      inf.readSpace();
      int h = inf.readInt(1, H - 2, "h_" + to_string(i + 1));
      inf.readSpace();
      int x = inf.readInt(1, W - w - 1, "x_" + to_string(i + 1));
      inf.readSpace();
      int y = inf.readInt(1, H - h - 1, "y_" + to_string(i + 1));
      inf.readSpace();
      int dx = inf.readInt(-1, 1, "dx_" + to_string(i + 1));
      inf.readSpace();
      int dy = inf.readInt(-1, 1, "dy_" + to_string(i + 1));
      inf.readEoln();
      ensuref(dx != 0, "dx should not be zero");
      ensuref(dy != 0, "dy should not be zero");
    }
  }

  inf.readEof();

  return 0;
}
