#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

// #define int long long
typedef long long ll;
typedef long double ld;


void solve() {
    int n;
    cin >> n;
    vector<int> lst(n);
    for (int i =0; i < n; i++) {
        cin >> lst[i];
    }
    vector<int> cur(n);
    vector<int> id(n + 1, 0);
    for (int i =0; i < n; i++) {
        cur[i] = n - i;
        id[n - i] = i;
    }
    vector<pair<int, int>> ans;
    int pref = 1;
    for (int i = n; i > 1; i--) {
        for (int j = i - 1; j >= pref; j--) {
            ans.push_back({i, j});
        }
    }
    for (int i =0; i < n; i++) {
        int x = lst[i];
        int pos = id[x];
        while (pos != i) {
            ans.push_back({cur[pos], cur[pos - 1]});
            swap(cur[pos], cur[pos - 1]);
            id[cur[pos]] = pos;
            id[cur[pos - 1]] = pos - 1;
            pos--;
        }

    }
    cout << ans.size() << '\n';
    for (auto i : ans) {
        cout << i.first << " " << i.second << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LC
    freopen("/Users/Iurii.Zaitsev/TUM/ICPC/y1/nerc_test/input.txt", "r", stdin);
    freopen("/Users/Iurii.Zaitsev/TUM/ICPC/y1/nerc_test/output.txt", "w", stdout);

#endif
    int t = 1;
    // cin >> t;
    for (int tt =0; tt < t; tt++) {
        solve();
    }

    return 0;
}
