#include <bits/stdc++.h>
using namespace std;

int main(){
	ios_base::sync_with_stdio(false), cin.tie(nullptr);
	int X;
	cin >> X;
	vector<int> program(1 << 12);
	int IO = (1 << 12) - 1;

	int halt = (1 << 16) - 1;
	int kill = 1 << 10;
	program[kill] = (kill + 3) << 4;
	program[kill+1] = IO << 4;
	program[kill+2] = halt;
	program[kill+3] = 0;

	int win = 2 << 10;
	program[win] = (win + 3) << 4;
	program[win+1] = IO << 4;
	program[win+2] = halt;
	program[win+3] = (1 << 16) - 1;

	int cur = 0;
	for(int i = 0; i < 16; i++){
		program[cur] = (IO << 4) + i;
		program[cur+1] = ((cur + 2) << 4) + 2;
		program[cur+2] = cur + 8;

		int b = 1 & (X >> i);
		program[cur + 8 + (1 - b) * 4] = 0;
		program[cur + 8 + (1 - b) * 4 + 1] = 0;
		program[cur + 8 + (1 - b) * 4 + 2] = kill;

		program[cur + 8 + b * 4] = 0;
		program[cur + 8 + b * 4 + 1] = 0;
		int nxt = (i == 15) ? win : cur + 16;
		program[cur + 8 + b * 4 + 2] = nxt;
		cur = nxt;
	}

	// for(int input = 0; input < (1 << 16); input++){
	// 	vector<int> memory = program;
	// 	memory[IO] = input;
	// 	int IP = 0;
	// 	while(IP <= (1 << 12) - 2){
	// 		cerr << IP << ' ';
	// 		int a = memory[IP];
	// 		int b = memory[IP + 1];
	// 		int val = (memory[a >> 4] >> (a % 16)) & 1;
	// 		memory[b >> 4] = (memory[b >> 4] & ~(1 << (b % 16))) | (val << (b % 16));
	// 		IP = memory[IP + 2];
	// 		if(IP == win) cerr << input << " WIN\n";
	// 	}
	// 	cerr << '\n';
	// 	bool ok = (memory[IO] & 1) == (input == X);
	// 	if(!ok){
	// 		cerr << X << ' ' << "FAIL" << '\n';
	// 		assert(false);
	// 	}
	// 	cerr << input << " OK " << '\n';
	// }

	int N = (1 << 12) - 1;
	for(int i = 0; i < N; i++){
		cout << hex << setw(4) << setfill('0') << program[i] << ' ';
	}
	cout << '\n';
}
