# Example solution for 0

io_word = 0x0fff
io_addr = io_word * 16
end = 0xfff

program = [0] * (16 * 3 + 3 + 64)

def instruction(ip, a, b, c = None):
    if c == None:
        c = ip + 3

    assert 0 <= a < 2 ** 16
    assert 0 <= b < 2 ** 16
    assert 0 <= c < 2 ** 16

    program[ip + 0] = a
    program[ip + 1] = b
    program[ip + 2] = c

for i in range(16):
    ip = i * 3
    instruction(ip, io_addr + i, (ip + 2) * 16 + 6)
    instruction(ip + 3 + 64, 0, io_addr, end)

instruction(16 * 3, 4, io_addr, end)

for w in program:
    print(f'{w:04x} ', end='')
