import re

def is_correct(expr):
	try:
		a,b = expr.split('=')
		if eval(a) != eval(b):
			return False
		for x in (a, b):
			if not re.match(r'^(0|([1-9](\d){0,9}))((\+|-)(0|([1-9](\d){0,9})))*$', x):
				return False
		return True
	except Exception as e:
		return False

expr = input()

def solve(expr):
	ans = ''
	if is_correct(expr):
		ans = "Correct"
	N = len(expr)
	for i in range(N):
		c = expr[i]
		if not c.isdigit():
			continue
		s2 = expr[:i] + expr[i+1:]
		for j in range(N):
			s3 = s2[:j] + c + s2[j:]
			if is_correct(s3):
				if not ans:
					ans = s3
	if not ans:
		return "Impossible"
	return ans

print(solve(expr))
