#include "fibonacci.h"

int main(int argc, char** argv) {
    registerGen(argc, argv, 1);
	int t = opt<int>("maxt");
    int maxn = opt<int>("maxn");
    ll maxk = opt<ll>("maxk");
    int nrand = opt<int>("nrand");
    int id = opt<int>("id");

    int sz = 0;
    int sumn = 0;

    init_f();

    auto fibs = gen_all_fib(maxk);

    vector<tuple<int, int, ll>> q;
    int i = 0;
    while (id--) {
        sz = 0;
        sumn = 0;
        q.clear();
        for (; i < fibs.size(); ++i) {
            bool flag = true;
            auto [n0, m0] = min_params(fibs[i]);
            for (int n = max(1, n0 - 1); n <= n0 + 3; ++n) {
                for (int m = max(2, m0 - 4); m <= min(m0 + 4, 2 * n - 1); m += 2) {
                    if (sz < t && sumn + n <= MAXSUMN) {
                        q.push_back({n, m, fibs[i]});
                        ++sz;
                        sumn += n;
                    } else {
                        flag = false;
                        break;
                    }
                }
                if (!flag) {
                    break;
                }
            }
            if (!flag) {
                break;
            }
            for (int j = 0; j < nrand; ++j) {
                int n = rnd.next(1, maxn);
                if (n == 1) {
                    continue;
                }
                int m = rnd.next(1, n - 1) * 2;
                if (sz < t && sumn + n <= MAXSUMN) {
                    q.push_back({n, m, fibs[i]});
                    ++sz;
                    sumn += n;
                } else {
                    flag = false;
                    break;
                }
            }
            if (!flag) {
                break;
            }
        }
    }

    cout << sz << "\n";
    for (auto [ni, mi, ki] : q) {
        cout << ni << " " << mi << " " << ki << "\n";
    }
    return 0;
}