/**
 *    author:  tourist
 *    created: 11.12.2024 02:19:11
**/
#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
#include "algo/debug.h"
#else
#define debug(...) 42
#endif

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt;
  cin >> tt;
  while (tt--) {
    int n;
    cin >> n;
    array<string, 2> s;
    cin >> s[0] >> s[1];
    vector<vector<int>> dp(n + 1, vector<int>(4));
    dp[0][0] = 1;
    for (int i = 0; i < n; ++i) {
      if (s[0][i] == '.' && s[1][i] == '.') {
        dp[i + 1][0] = min(dp[i][0] + dp[i][3], 2);
        dp[i + 1][1] = dp[i][2];
        dp[i + 1][2] = dp[i][1];
        dp[i + 1][3] = dp[i][0];
      } else if (s[0][i] == '.') {
        dp[i + 1][0] = dp[i][1];
        dp[i + 1][1] = dp[i][0];
      } else if (s[1][i] == '.') {
        dp[i + 1][0] = dp[i][2];
        dp[i + 1][2] = dp[i][0];
      } else {
        dp[i + 1][0] = dp[i][0];
      }
    }
    cout << (dp[n][0] == 0 ? "None" : (dp[n][0] > 1 ? "Multiple" : "Unique")) << '\n';
  }
  return 0;
}
