#include <bits/stdc++.h>


using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;

#define all(a) (a).begin(), (a).end()
#define int long long

const int N = 5e5 + 10;
vector<pii> g[N];
vector<int> ash[N];
vector<int> aall[N];
vector<pii> ag[N];
const int inf = 1e12;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v, t;
        cin >> u >> v >> t;
        --u, --v;
        g[u].push_back({v, t});
        ag[v].push_back({u, t});
    }

    vector<int> dst(n, inf);
    dst[n - 1] = 0;

    set<pii> qu = {{0, n - 1}};
    while (!qu.empty()) {
        auto [d, u] = *qu.begin();
        qu.erase(qu.begin());

        for (auto [to, dd] : ag[u]) {
            if (dst[to] > d + dd) {
                qu.erase({dst[to], to});
                dst[to] = d + dd;
                qu.insert({dst[to], to});
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (auto [to, d] : g[i]) {
            if (dst[i] == dst[to] + d) {
                ash[to].push_back(i);  // unique?
            }
            aall[to].push_back(i);
        }
    }
    for (int i = 0; i < n; ++i) {
        sort(all(ash[i]));
        sort(all(aall[i]));
        ash[i].resize(unique(all(ash[i])) - ash[i].begin());
        aall[i].resize(unique(all(aall[i])) - aall[i].begin());
    }

    vector<int> dsh(n, 0);
    for (int i = 0; i < n; ++i) {
        for (int u : ash[i]) {
            dsh[u]++;
        }
    }

    vector<int> mark(n, n);
    mark[n - 1] = -2;

    int cur_lvl = -1;
    vector<int> cur_v;
    for (int i = 0; i < n; ++i) {
        if (dst[i] == inf) {
            cur_v.push_back(i);
            mark[i] = cur_lvl;
        }
    }

    vector<int> seen_sh(n, 0);

    while (!cur_v.empty()) {
        cur_lvl++;
        vector<int> new_v;
        for (int i : cur_v) {
            for (auto u : aall[i]) {
                if (mark[u] > cur_lvl) {
                    mark[u] = cur_lvl;
                    new_v.push_back(u);
                }
            }
        }
        int at = 0;
        while (at < new_v.size()) {
            int i = new_v[at];
            for (int u : ash[i]) {
                seen_sh[u]++;
                if (seen_sh[u] == dsh[u] && mark[u] > cur_lvl) {
                    mark[u] = cur_lvl;
                    new_v.push_back(u);
                }
            }
            ++at;
        }
        cur_v = new_v;
    }

    mark[n - 1] = n;

    cout << mark[0] << '\n';
}
