#include <bits/stdc++.h>

using namespace std;

#ifdef DBG
#define debugf(s, ...) do { fprintf(stderr, "(" #__VA_ARGS__ "): "); \
                            fprintf(stderr, s, __VA_ARGS__);         \
                            fprintf(stderr, "\n");} while (false)
#define debugv(c, v) do { fprintf(stderr, "("#v"):\n"); int idx = 0; for (auto elem: (v)) {fprintf(stderr, "\t");debugf("%d " c, idx, elem); ++idx;}} while (false)
#else
#define debugf(...) do {} while (false)
#define debugv(...) do {} while (false)
#endif

using i64 = int64_t;

constexpr int mod = 998'244'353;

#define CE constexpr
#define all(x) x.begin(), x.end()
#define int long long

void solve(int tcc) {
    int n, m, q;
    cin >> n >> m >> q;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].second;
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
    }
    vector<int> epi(m);
    for (int i = 0; i < m; ++i) {
        cin >> epi[i];
    }
    sort(a.begin(), a.end());
    reverse(a.begin(), a.end());
    int ttend = a[0].first;
    for (int i = 0; i < n; ++i) {
        a[i].first = min(a[i].first, ttend);
        ttend = min(a[i].first-a[i].second, ttend);
    }
    reverse(all(a));
    int ind = 0;
    int smb = 0;
    vector<pair<int, int>> quer(q);
    for (int i = 0; i < q; ++i) {
        cin >> quer[i].first;
        quer[i].second = i;
    }
    int wth = 0;
    vector<int> ans(q);
    sort(quer.begin(), quer.end());
    for (int i = 0; i < q; ++i) {
        int mx = quer[i].first;
        while  (ind != n and a[ind].first <= mx) {
            smb += a[ind].second;
            ind++;
        }
        int mval = mx - smb;
        if (ind != n and a[ind].first-a[ind].second < mx)
            mval = a[ind].first-a[ind].second - smb;
        while (wth != m and mval >= epi[wth]) {
            smb += epi[wth];
            //cerr << mval  << ' ' << epi[wth]  << endl;
            mval -= epi[wth];
            wth++;
        }
        ans[quer[i].second] = wth;
    }
    for (int i = 0; i < ans.size(); ++i) {
        cout << ans[i] << ' ';
    }
    cout << '\n';
}

signed main() {
#ifndef DBG
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
#endif


    int t = 1;
    cin >> t;
    for (int i = 0; i < t; ++i) solve(i);
}