#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

int main(int argc, char* argv[]) {
  registerGen(argc, argv, 1);

  int t = opt<int>("t");
  int max_n = opt<int>("max_n");
  int max_sum = opt<int>("max_sum");

  auto ns = rnd.partition(t, max_sum, 6);
  
  cout << t << '\n';
  for (int q = 0; q < t; q++) {
    int n = ns[q];
    vector<pair<int, int>> options;
    for (int W = 3; W <= n - 3; W++) {
      if (W <= max_n && n - W <= max_n) {
        options.emplace_back(W, n - W);
      }
    }
    int id = rnd.next(options.size());
    auto [W, H] = options[id];
    cout << W << " " << H << '\n';
    for (int i = 0; i < 2; i++) {
      int w = rnd.next(1, W - 2);
      int h = rnd.next(1, H - 2);
      int x = rnd.next(1, W - w - 1);
      int y = rnd.next(1, H - h - 1);
      int dx = rnd.next(0, 1) * 2 - 1;
      int dy = rnd.next(0, 1) * 2 - 1;
      cout << w << " " << h << " " << x << " " << y << " " << dx << " " << dy << '\n';
    }
 }

  return 0;
}