#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

int main(int argc, char* argv[]) {
  registerGen(argc, argv, 1);

  int t = opt<int>("t");
  int max_n = opt<int>("max_n");
  int id = opt<int>("id");

  vector<array<int, 14>> tests;
  for (int sum = 6; sum <= 9; sum++) {
    for (int W = 3; W <= sum - 3; W++) {
      int H = sum - W;
      for (int w = 1; w <= W - 2; w++) {
        for (int h = 1; h <= H - 2; h++) {
          for (int x = 1; x <= W - w - 1; x++) {
            for (int y = 1; y <= H - h - 1; y++) {
              for (int dx = -1; dx <= 1; dx += 2) {
                for (int dy = -1; dy <= 1; dy += 2) {
      for (int w2 = 1; w2 <= W - 2; w2++) {
        for (int h2 = 1; h2 <= H - 2; h2++) {
          for (int x2 = 1; x2 <= W - w2 - 1; x2++) {
            for (int y2 = 1; y2 <= H - h2 - 1; y2++) {
              for (int dx2 = -1; dx2 <= 1; dx2 += 2) {
                for (int dy2 = -1; dy2 <= 1; dy2 += 2) {
                  tests.push_back({W, H, w, h, x, y, dx, dy, w2, h2, x2, y2, dx2, dy2});
                }
              }
            }
          }
        }
      }
                }
              }
            }
          }
        }
      }
    }
  }
  shuffle(tests.begin(), tests.end());
  vector<array<int, 14>> actual;
  int beg = 0;
  while (beg < int(tests.size())) {
    int end = beg;
    int sum_wh = 0;
    while (end < int(tests.size())) {
      if (int(actual.size()) == t) {
        break;
      }
      if (sum_wh + tests[end][0] + tests[end][1] > max_n) {
        break;
      }
      sum_wh += tests[end][0] + tests[end][1];
      actual.push_back(tests[end]);
      end += 1;
    }
    if (id == 1) {
      break;
    }
    actual.clear();
    id -= 1;
    beg = end;
  }
  cout << actual.size() << '\n';
  for (auto& test : actual) {
    for (int i = 0; i < 14; i++) {
      cout << test[i];
      if (i == 1 || i == 7 || i == 13) {
        cout << '\n';
      } else {
        cout << " ";
      }
    }
  }
  return 0;
}